﻿<?xml version="1.0" encoding="UTF-8"?>

<!--
******************************************************************************************************************

		OIOUBL Stylesheet	

		title= PCM_2_OIOUBL_v01p06.xsl	
		replaces= PCM_2_OIOUBL_v01p05.xsl	
		publisher= "IT og Telestyrelsen"
		creator= "Finn Christensen"
		created= 2006-12-05
		modified= 2008-02-04
		issued= 2008-02-04
		conformsTo= OIOUBL stylesheet package
		description= "This document is produced as part of the OIOUBL stylesheet package"
		rights= "It can be used following the Common Creative Licence"
		
		all terms derived from http://dublincore.org/documents/dcmi-terms/

		For more information, see www.oioubl.dk	or email oioubl@itst.dk
		
******************************************************************************************************************
-->

<xsl:stylesheet version="1.0"
	xmlns:xsl  = "http://www.w3.org/1999/XSL/Transform"
	xmlns:xsi  = "http://www.w3.org/2001/XMLSchema-instance" 
	xmlns:com  = "http://rep.oio.dk/ubl/xml/schemas/0p71/common/" 
	xmlns:main = "http://rep.oio.dk/ubl/xml/schemas/0p71/maindoc/"
	xmlns:pcm  = "http://rep.oio.dk/ubl/xml/schemas/0p71/pcm/"
	xmlns:xs   = "http://www.w3.org/2001/XMLSchema"
	xmlns      = "urn:oasis:names:specification:ubl:schema:xsd:CreditNote-2"
	xmlns:cac  = "urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2"
	xmlns:cbc  = "urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2"
	xmlns:ccts = "urn:oasis:names:specification:ubl:schema:xsd:CoreComponentParameters-2"
	xmlns:sdt  = "urn:oasis:names:specification:ubl:schema:xsd:SpecializedDatatypes-2"
	xmlns:udt  = "urn:un:unece:uncefact:data:specification:UnqualifiedDataTypesSchemaModule:2"
                                                                       exclude-result-prefixes="com main pcm xs">

	<xsl:output method="xml" encoding="UTF-8" indent="yes"/>

	<xsl:strip-space elements="*" />

     	<xsl:template match="/">
		<xsl:apply-templates/>
     	</xsl:template>

	<xsl:template match="*">
		<Fejl>
			<Fejltekst>Fatal fejl: Dokumenttypen supporteres ikke! Dette stylesheet kan alene konvertere et OIOXML PCM dokument.</Fejltekst>
			<Input><xsl:value-of select="."/></Input>
		</Fejl>
	</xsl:template>


	<xsl:template match="/pcm:Invoice">

		<!-- Faste parametre (disse kan/skal tilpasses inden brug af sylesheetet) -->
		<xsl:variable name="UBLVersionID"		select="'2.0'"/>
		<xsl:variable name="CustomizationID"		select="'OIOUBL-2.01'"/>
		<xsl:variable name="ProfileID"			select="'Procurement-BilSim-1.0'"/>

		<xsl:variable name="CopyIndicator"		select="'false'"/>

		<xsl:variable name="CountryCode"		select="'DK'"/>

		<xsl:variable name="SenderEndpointID"		select="'12345678'"/>
		<xsl:variable name="SenderEndpointIDscheme"	select="'CVR'"/>
		<xsl:variable name="UseSenderEndpointDefaults"	select="'false'"/>

		<xsl:variable name="DefaultMomsPercent"		select="'25'"/>
		<xsl:variable name="UseDefaultMomsPercent"	select="'false'"/>

		<xsl:variable name="DefaultItemSchemeID"	select="'GTIN'"/>
		<xsl:variable name="UseDefaultItemSchemeID"	select="'false'"/>

		<xsl:variable name="DefaultUnitCode"		select="'EA'"/>
		<xsl:variable name="UseDefaultUnitCode"		select="'true'"/>
		<!-- Slut faste parametre -->


		<!-- Betingede parametre -->
		<xsl:variable name="Linjespecificeret">
			<xsl:choose>
				<xsl:when test="contains(com:ReferencedOrder/com:BuyersOrderID, 'Linjespecificeret')">true</xsl:when>
				<xsl:otherwise>false</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="Vareafsendelse">
			<xsl:choose>
				<xsl:when test="string(com:SellerParty[com:Address/com:ID = 'Vareafsendelse'])">true</xsl:when>
				<xsl:otherwise>false</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="Afgift">
			<xsl:choose>
				<xsl:when test="string(com:AllowanceCharge[com:ID = 'Afgift'])">true</xsl:when>
				<xsl:otherwise>false</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="Told">
			<xsl:choose>
				<xsl:when test="string(com:AllowanceCharge[com:ID = 'Told'])">true</xsl:when>
				<xsl:otherwise>false</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<!-- Globale variable -->
		<xsl:variable name="BuyersReferenceID"	select="com:BuyersReferenceID"/>
		<xsl:variable name="CurrencyCode"	select="main:InvoiceCurrencyCode"/>


		<!-- Start på OIOUBL-2.01 kreditnota -->
		<CreditNote>

			<xsl:attribute name="xsi:schemaLocation">urn:oasis:names:specification:ubl:schema:xsd:CreditNote-2 UBL-CreditNote-2.0.xsd</xsl:attribute>

			<cbc:UBLVersionID><xsl:value-of select="$UBLVersionID"/></cbc:UBLVersionID>
			<cbc:CustomizationID><xsl:value-of select="$CustomizationID"/></cbc:CustomizationID>
			<cbc:ProfileID schemeAgencyID="320" schemeID="urn:oioubl:id:profileid-1.1"><xsl:value-of select="$ProfileID"/></cbc:ProfileID>
			<cbc:ID><xsl:value-of select="com:ID"/></cbc:ID>
			<cbc:CopyIndicator><xsl:value-of select="$CopyIndicator"/></cbc:CopyIndicator>
			<cbc:IssueDate><xsl:value-of select="com:IssueDate"/></cbc:IssueDate>
			<xsl:if test="string(com:Note)"><cbc:Note><xsl:value-of select='translate(com:Note,"&#13;", " ")'/></cbc:Note></xsl:if>
			<cbc:DocumentCurrencyCode><xsl:value-of select="$CurrencyCode"/></cbc:DocumentCurrencyCode>
			<xsl:if test="string(com:BuyerParty/com:AccountCode)"><cbc:AccountingCost><xsl:value-of select="com:BuyerParty/com:AccountCode"/></cbc:AccountingCost></xsl:if>


			<!-- DiscrepancyResponse -->
			<xsl:call-template name="DiscrepancyResponse"/>


			<!-- OrderReference -->
			<xsl:call-template name="OrderReference"/>

			<!-- Signature -->
			<xsl:apply-templates select="com:ValidatedSignature"/>

			<!-- AccountingSupplierParty -->
			<cac:AccountingSupplierParty>
				<xsl:apply-templates select="com:SellerParty">
					<xsl:with-param name="CountryCode" select="$CountryCode"/>
					<xsl:with-param name="BuyersReferenceID" select="$BuyersReferenceID"/>
				</xsl:apply-templates>
			</cac:AccountingSupplierParty>

			<!-- AccountingCustomerParty -->
			<cac:AccountingCustomerParty>
				<xsl:if test = "count(com:BuyerParty) = 1 and count(com:BuyerParty[com:Address/com:ID = 'Fakturering']) = 0">
					<xsl:apply-templates select="com:BuyerParty">
						<xsl:with-param name="CountryCode" select="$CountryCode"/>
						<xsl:with-param name="BuyersReferenceID" select="$BuyersReferenceID"/>
					</xsl:apply-templates>
				</xsl:if>
				<xsl:apply-templates select="com:BuyerParty[com:Address/com:ID = 'Fakturering']">
					<xsl:with-param name="CountryCode" select="$CountryCode"/>
					<xsl:with-param name="BuyersReferenceID" select="$BuyersReferenceID"/>
				</xsl:apply-templates>
			</cac:AccountingCustomerParty>

			<!-- PayeeParty -->

			<!-- BuyerCustomerParty (haves ej i OIOUBL) -->

			<!-- SellerSupplierParty (haves ej i OIOUBL) -->

			<!-- AllowanceCharge -->
			<xsl:apply-templates select="com:AllowanceCharge">
				<xsl:with-param name="LineExtensionTotalAmount" select="com:LegalTotals/com:LineExtensionTotalAmount"/>
				<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
				<xsl:with-param name="CountryCode" select="$CountryCode"/>
				<xsl:with-param name="DefaultMomsPercent" select="$DefaultMomsPercent"/>
			</xsl:apply-templates>

			<!-- TaxTotal -->
			<xsl:call-template name="TaxTotal">
				<xsl:with-param name="Afgift" select="$Afgift"/>
				<xsl:with-param name="Told" select="$Told"/>
				<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
				<xsl:with-param name="CountryCode" select="$CountryCode"/>
			</xsl:call-template>

			<!-- LegalMonetaryTotal -->
			<xsl:call-template name="LegalMonetaryTotal">
				<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
			</xsl:call-template>

			<!-- CreditNoteLine -->
			<xsl:apply-templates select="com:InvoiceLine">
				<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
				<xsl:with-param name="CountryCode" select="$CountryCode"/>
				<xsl:with-param name="DefaultItemSchemeID" select="$DefaultItemSchemeID"/>
				<xsl:with-param name="UseDefaultItemSchemeID" select="$UseDefaultItemSchemeID"/>
				<xsl:with-param name="Linjespecificeret" select="$Linjespecificeret"/>
				<xsl:with-param name="DefaultUnitCode" select="$DefaultUnitCode"/>
				<xsl:with-param name="UseDefaultUnitCode" select="$UseDefaultUnitCode"/>
				<xsl:with-param name="DefaultMomsPercent" select="$DefaultMomsPercent"/>
			</xsl:apply-templates>
		</CreditNote>
	</xsl:template>



	<!-- .............................. -->
	<!--           Templates            -->
	<!-- .............................. -->


	<!-- DiscrepancyResponse template -->
	<xsl:template name="DiscrepancyResponse">
		<xsl:variable name="t1">
			<xsl:choose>
				<xsl:when test="string(com:Note)"><xsl:value-of select="com:Note"/></xsl:when>
				<xsl:otherwise>Kreditnota ifølge aftale</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<cac:DiscrepancyResponse>
			<cbc:ReferenceID>1</cbc:ReferenceID>
			<cbc:Description><xsl:value-of select="$t1"/></cbc:Description>
		</cac:DiscrepancyResponse>
	</xsl:template>


	<!-- BillingReference template -->
	<xsl:template name="BillingReference">
	</xsl:template>


	<!-- OrderReference template -->
	<xsl:template name="OrderReference">
		<cac:OrderReference>
			<cbc:ID><xsl:value-of select="com:ReferencedOrder/com:BuyersOrderID"/></cbc:ID>
			<xsl:if test="string(com:ReferencedOrder/com:SellersOrderID)"><cbc:SalesOrderID><xsl:value-of select="com:ReferencedOrder/com:SellersOrderID"/></cbc:SalesOrderID></xsl:if>
			<cbc:IssueDate><xsl:value-of select="com:ReferencedOrder/com:IssueDate"/></cbc:IssueDate>
		</cac:OrderReference>
	</xsl:template>


	<!-- Signature template -->
	<xsl:template match="com:ValidatedSignature">
		<xsl:variable name="t1">
			<xsl:choose>
				<xsl:when test="string(com:SignatureID)"><xsl:value-of select="com:SignatureID"/></xsl:when>
				<xsl:otherwise>1</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="t2">
			<xsl:choose>
				<xsl:when test="string(com:ValidationDateTime)"><xsl:value-of select="substring(com:ValidationDateTime, 1, 10)"/></xsl:when>
				<xsl:otherwise></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="t3">
			<xsl:choose>
				<xsl:when test="string(com:ValidationDateTime)"><xsl:value-of select="substring(com:ValidationDateTime, 12, 8)"/></xsl:when>
				<xsl:otherwise></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<cac:Signature>
			<cbc:ID><xsl:value-of select="$t1"/></cbc:ID>
			<xsl:if test="string($t2)"><cbc:ValidationDate><xsl:value-of select="$t2"/></cbc:ValidationDate></xsl:if>
			<xsl:if test="string($t3)"><cbc:ValidationTime><xsl:value-of select="$t3"/></cbc:ValidationTime></xsl:if>
			<xsl:if test="string(com:ValidatorID)"><cbc:ValidatorID><xsl:value-of select="com:ValidatorID"/></cbc:ValidatorID></xsl:if>
			<cac:SignatoryParty>
				<cac:PartyName>
					<cbc:Name>Hardcoded by OIO2UBL stylesheet</cbc:Name>
				</cac:PartyName>
			</cac:SignatoryParty>
			<xsl:if test="string(com:Signature)">
				<cac:DigitalSignatureAttachment>
					<cbc:EmbeddedDocumentBinaryObject mimeCode="text/xml"><xsl:value-of select="com:Signature"/></cbc:EmbeddedDocumentBinaryObject>
				</cac:DigitalSignatureAttachment>
			</xsl:if>
		</cac:Signature>
	</xsl:template>


	<!--  Party template -->
	<xsl:template match="com:BuyerParty | com:SellerParty">
		<xsl:param name="CountryCode"/>
		<xsl:param name="BuyersReferenceID"/>
		<cac:Party>
			<xsl:call-template name="EndpointID"><xsl:with-param name="BuyersReferenceID" select="$BuyersReferenceID"/></xsl:call-template>
			<xsl:call-template name="PartyIdentification"/>
			<xsl:call-template name="PartyName"><xsl:with-param name="p1" select="com:PartyName/com:Name"/></xsl:call-template>
			<cac:PostalAddress>
				<xsl:call-template name="Address">
					<xsl:with-param name="p1" select="com:Address/com:ID"/>
					<xsl:with-param name="p2" select="com:Address/com:Street"/>
					<xsl:with-param name="p3" select="com:Address/com:AdditionalStreet"/>
					<xsl:with-param name="p4" select="com:Address/com:HouseNumber"/>
					<xsl:with-param name="p5" select="com:Address/com:InhouseMail"/>
					<xsl:with-param name="p6" select="com:Address/com:CityName"/>
					<xsl:with-param name="p7" select="com:Address/com:PostalZone"/>
					<xsl:with-param name="p8" select="com:Address/com:Country/com:Code"/>
					<xsl:with-param name="p9" select="''"/>
					<xsl:with-param name="CountryCode" select="$CountryCode"/>
				</xsl:call-template>
			</cac:PostalAddress>
			<xsl:call-template name="PartyTaxScheme"/>
			<xsl:call-template name="PartyLegalEntity"/>
			<xsl:call-template name="Contact"/>
		</cac:Party>
	</xsl:template>


	<!-- AllowanceCharge template (match) -->
	<xsl:template match="com:AllowanceCharge">
		<xsl:param name="LineExtensionTotalAmount"/>
		<xsl:param name="CurrencyCode"/>
		<xsl:param name="CountryCode"/>
		<xsl:param name="DefaultMomsPercent"/>
		<xsl:variable name="t1"	select="com:ID"/>
		<xsl:choose>
			<xsl:when test="$t1 = 'Rabat'">
				<xsl:call-template name="AllowanceCharge">
					<xsl:with-param name="pID" select="position()"/>
					<xsl:with-param name="pChargeIndicator" select="'false'"/> 
					<xsl:with-param name="LineExtensionTotalAmount" select="$LineExtensionTotalAmount"/>
					<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
					<xsl:with-param name="CountryCode" select="$CountryCode"/>
					<xsl:with-param name="DefaultMomsPercent" select="$DefaultMomsPercent"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$t1 = 'Gebyr' or $t1 = 'Fragt'">
				<xsl:call-template name="AllowanceCharge">
					<xsl:with-param name="pID" select="position()"/>
					<xsl:with-param name="pChargeIndicator" select="'true'"/> 
					<xsl:with-param name="LineExtensionTotalAmount" select="$LineExtensionTotalAmount"/>
					<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
					<xsl:with-param name="CountryCode" select="$CountryCode"/>
					<xsl:with-param name="DefaultMomsPercent" select="$DefaultMomsPercent"/>
				</xsl:call-template>
			</xsl:when>
		</xsl:choose>
	</xsl:template>


	<!-- TaxTotal template (call) -->
	<xsl:template name="TaxTotal">
		<xsl:param name="Afgift"/>
		<xsl:param name="Told"/>
		<xsl:param name="CurrencyCode"/>
		<xsl:param name="CountryCode"/>
		<xsl:variable name="t1"	select="format-number(sum(//com:TaxTotal/com:CategoryTotal/com:TaxAmounts/com:TaxAmount), '0.00')"/>

		<xsl:if test="$Afgift = 'true'">
			<xsl:apply-templates select="com:AllowanceCharge[com:ID = 'Afgift']" mode="skat">
				<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
				<xsl:with-param name="CountryCode" select="$CountryCode"/>
			</xsl:apply-templates>
		</xsl:if>
		<xsl:if test="$Told = 'true'">
			<xsl:apply-templates select="com:AllowanceCharge[com:ID = 'Told']" mode="skat">
				<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
				<xsl:with-param name="CountryCode" select="$CountryCode"/>
			</xsl:apply-templates>
		</xsl:if>
		<cac:TaxTotal>
			<cbc:TaxAmount currencyID="{$CurrencyCode}"><xsl:value-of select="$t1"/></cbc:TaxAmount>
			<xsl:apply-templates select="com:TaxTotal">
					<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
					<xsl:with-param name="CountryCode" select="$CountryCode"/>
			</xsl:apply-templates>
		</cac:TaxTotal>
	</xsl:template>


	<!-- LegalMonetaryTotal template -->
	<xsl:template name="LegalMonetaryTotal">
		<xsl:param name="CurrencyCode"/>
		<xsl:variable name="t1"	select="format-number(sum(//com:TaxTotal/com:CategoryTotal/com:TaxAmounts/com:TaxAmount), '.00')"/>
		<xsl:variable name="t2"	select="format-number(sum(/pcm:Invoice/com:AllowanceCharge[com:ID = 'Rabat']/com:AllowanceChargeAmount), '.00')"/>
		<xsl:variable name="t3"	select="format-number(sum(/pcm:Invoice/com:AllowanceCharge[com:ID = 'Gebyr']/com:AllowanceChargeAmount), '.00')"/>
		<xsl:variable name="t4"	select="format-number(sum(/pcm:Invoice/com:AllowanceCharge[com:ID = 'Fragt']/com:AllowanceChargeAmount), '.00')"/>
		<xsl:variable name="t6"	select="format-number(sum(/pcm:Invoice/com:AllowanceCharge[com:ID = 'Afgift']/com:AllowanceChargeAmount), '.00')"/>
		<xsl:variable name="t7"	select="format-number(sum(/pcm:Invoice/com:AllowanceCharge[com:ID = 'Told']/com:AllowanceChargeAmount), '.00')"/>
		<xsl:variable name="t8"	select="format-number($t1 + $t6 + $t7, '0.00')"/>
		<xsl:variable name="t5"	select="format-number($t3 + $t4, '.00')"/>
		<cac:LegalMonetaryTotal>
			<cbc:LineExtensionAmount currencyID ="{$CurrencyCode}"><xsl:value-of select="com:LegalTotals/com:LineExtensionTotalAmount"/></cbc:LineExtensionAmount>
			<cbc:TaxExclusiveAmount currencyID ="{$CurrencyCode}"><xsl:value-of select="$t8"/></cbc:TaxExclusiveAmount>
			<cbc:TaxInclusiveAmount currencyID ="{$CurrencyCode}"><xsl:value-of select="com:LegalTotals/com:ToBePaidTotalAmount"/></cbc:TaxInclusiveAmount>
			<xsl:if test="number($t2)"><cbc:AllowanceTotalAmount currencyID ="{$CurrencyCode}"><xsl:value-of select="$t2"/></cbc:AllowanceTotalAmount></xsl:if>
			<xsl:if test="number($t5)"><cbc:ChargeTotalAmount currencyID ="{$CurrencyCode}"><xsl:value-of select="$t5"/></cbc:ChargeTotalAmount></xsl:if>
			<cbc:PayableAmount currencyID ="{$CurrencyCode}"><xsl:value-of select="com:LegalTotals/com:ToBePaidTotalAmount"/></cbc:PayableAmount>
		</cac:LegalMonetaryTotal>
	</xsl:template>


	<!-- Kreditnotalinje template -->
	<xsl:template match="com:InvoiceLine">
		<xsl:param name="CurrencyCode"/>
		<xsl:param name="CountryCode"/>
		<xsl:param name="DefaultItemSchemeID"/>
		<xsl:param name="UseDefaultItemSchemeID"/>
		<xsl:param name="Linjespecificeret"/>
		<xsl:param name="DefaultUnitCode"/>
		<xsl:param name="UseDefaultUnitCode"/>
		<xsl:param name="DefaultMomsPercent"/>
		<cac:CreditNoteLine>
			<cbc:ID><xsl:value-of select="com:ID"/></cbc:ID>
			<xsl:if test="string(com:Note)"><cbc:Note><xsl:value-of select='translate(com:Note,"&#13;", " ")'/></cbc:Note></xsl:if>
			<xsl:call-template name="UnitCode">
				<xsl:with-param name="p1" select="'invqu'"/>
				<xsl:with-param name="p2" select="com:InvoicedQuantity/@unitCode"/> 
				<xsl:with-param name="p3" select="com:InvoicedQuantity"/>
				<xsl:with-param name="DefaultUnitCode" select="$DefaultUnitCode"/>
				<xsl:with-param name="UseDefaultUnitCode" select="$UseDefaultUnitCode"/>
			</xsl:call-template>
			<cbc:LineExtensionAmount currencyID="{com:LineExtensionAmount/@currencyID}"><xsl:value-of select="com:LineExtensionAmount"/></cbc:LineExtensionAmount>
			<xsl:call-template name="OrderLineReference">
				<xsl:with-param name="Linjespecificeret" select="$Linjespecificeret"/>
			</xsl:call-template>
			<xsl:call-template name="AllowanceCharge_Line">
				<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
				<xsl:with-param name="CountryCode" select="$CountryCode"/>
				<xsl:with-param name="DefaultMomsPercent" select="$DefaultMomsPercent"/>
			</xsl:call-template>
			<xsl:call-template name="TaxTotal_Line">
				<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
				<xsl:with-param name="CountryCode" select="$CountryCode"/>
				<xsl:with-param name="DefaultMomsPercent" select="$DefaultMomsPercent"/>
			</xsl:call-template>

			<xsl:call-template name="Item">
				<xsl:with-param name="DefaultItemSchemeID" select="$DefaultItemSchemeID"/>
				<xsl:with-param name="UseDefaultItemSchemeID" select="$UseDefaultItemSchemeID"/>
			</xsl:call-template>
			<xsl:call-template name="Price">
				<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
				<xsl:with-param name="DefaultUnitCode" select="$DefaultUnitCode"/>
				<xsl:with-param name="UseDefaultUnitCode" select="$UseDefaultUnitCode"/>
			</xsl:call-template>
		</cac:CreditNoteLine>
	</xsl:template>


	<!-- .............................. -->
	<!--   Utility Templates            -->
	<!-- .............................. -->


	<!-- OrderLineReference template -->
	<xsl:template name="OrderLineReference">
		<xsl:param name="Linjespecificeret"/>
		<xsl:if test="$Linjespecificeret = 'true'">
			<cac:OrderLineReference>
				<cbc:LineID><xsl:value-of select="com:ID"/></cbc:LineID>
				<cac:OrderReference>
					<cbc:ID><xsl:value-of select="com:ReferencedOrderLine/com:BuyersID"/></cbc:ID>
					<cbc:SalesOrderID><xsl:value-of select="com:ReferencedOrderLine/com:SellersID"/></cbc:SalesOrderID>
				</cac:OrderReference>
			</cac:OrderLineReference>
		</xsl:if>
	</xsl:template>


	<!-- AllowanceCharge_Line template -->
	<xsl:template name="AllowanceCharge_Line">
		<xsl:param name="CurrencyCode"/>
		<xsl:param name="CountryCode"/>
		<xsl:param name="DefaultMomsPercent"/>
		<xsl:apply-templates select="com:AllowanceCharge">
			<xsl:with-param name="LineExtensionTotalAmount" select="com:LineExtensionAmount"/>
			<xsl:with-param name="CurrencyCode" select="$CurrencyCode"/>
			<xsl:with-param name="CountryCode" select="$CountryCode"/>
			<xsl:with-param name="DefaultMomsPercent" select="$DefaultMomsPercent"/>
		</xsl:apply-templates>
	</xsl:template>


	<!-- TaxTotal_Line template -->
	<xsl:template name="TaxTotal_Line">
		<xsl:param name="CurrencyCode"/>
		<xsl:param name="CountryCode"/>
		<xsl:param name="DefaultMomsPercent"/>
		<xsl:variable name="t1"	select="com:LineExtensionAmount"/>
		<xsl:variable name="t2">
			<xsl:choose>
				<xsl:when test="com:Item/com:Tax/com:RateCategoryCodeID = 'VAT' or com:Item/com:Tax/com:TypeCode = 'VAT'">StandardRated</xsl:when>
				<xsl:when test="com:Item/com:Tax/com:RateCategoryCodeID = 'ZERO-RATED' or com:Item/com:Tax/com:TypeCode = 'ZERO-RATED'">ZeroRated</xsl:when>
				<xsl:otherwise>StandardRated</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="t3">
			<xsl:choose>
				<xsl:when test="com:Item/com:Tax/com:RatePercentNumeric = '25'"><xsl:value-of select="'25'"/></xsl:when>
				<xsl:when test="com:Item/com:Tax/com:RatePercentNumeric = '00'"><xsl:value-of select="'00'"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="$DefaultMomsPercent"/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="t4"	select="format-number($t3 div 100, '.00')"/>
		<xsl:variable name="t5">
			<xsl:choose>
				<xsl:when test="$t4 = '.00'"><xsl:value-of select="'.00'"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="format-number($t4 * $t1, '.00')"/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<cac:TaxTotal>
			<cbc:TaxAmount currencyID="{$CurrencyCode}"><xsl:value-of select="$t5"/></cbc:TaxAmount>
			<cac:TaxSubtotal>
				<cbc:TaxableAmount currencyID="{$CurrencyCode}"><xsl:value-of select="$t1"/></cbc:TaxableAmount>
				<cbc:TaxAmount currencyID="{$CurrencyCode}"><xsl:value-of select="$t5"/></cbc:TaxAmount>
				<cac:TaxCategory>
					<cbc:ID schemeAgencyID="320" schemeID="urn:oioubl:id:taxcategoryid-1.1"><xsl:value-of select="$t2"/></cbc:ID>
					<cbc:Percent><xsl:value-of select="$t3"/></cbc:Percent>
					<cac:TaxScheme>
						<cbc:ID schemeAgencyID="320" schemeID="urn:oioubl:id:taxschemeid-1.1">63</cbc:ID>
						<cbc:Name>Moms</cbc:Name>
					</cac:TaxScheme>
				</cac:TaxCategory>
			</cac:TaxSubtotal>
		</cac:TaxTotal>
	</xsl:template>


	<!-- Item template -->
	<xsl:template name="Item">
		<xsl:param name="DefaultItemSchemeID"/>
		<xsl:param name="UseDefaultItemSchemeID"/>
		<xsl:variable name="t1"	select="com:Item/com:ID"/>
		<xsl:variable name="t2"	select="com:Item/com:ID/@schemeID"/>
		<xsl:variable name="t5"	select="com:Item/com:Description"/>
		<xsl:variable name="t6"	select="substring($t5, 1, 15)"/>
		<cac:Item>
			<cbc:Description><xsl:value-of select="$t5"/></cbc:Description>
			<cbc:Name><xsl:value-of select="$t6"/></cbc:Name>
			<xsl:apply-templates select="com:Item/com:BuyersItemIdentification">
				<xsl:with-param name="DefaultItemSchemeID" select="$DefaultItemSchemeID"/>
				<xsl:with-param name="UseDefaultItemSchemeID" select="$UseDefaultItemSchemeID"/>
			</xsl:apply-templates>
			<cac:SellersItemIdentification>
				<xsl:variable name="t4">
					<xsl:choose>
						<xsl:when test="$t2 = 'EAN' or $t2 = 'EAN-13'">GTIN</xsl:when>
						<xsl:when test="not(string($t2))">n/a</xsl:when>
						<xsl:otherwise><xsl:value-of select="$t2"/></xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:choose>
					<xsl:when test="$UseDefaultItemSchemeID = 'true'">
						<xsl:variable name="t3">
							<xsl:choose>
								<xsl:when test="$t4 = 'n/a'"><xsl:value-of select="$DefaultItemSchemeID"/></xsl:when>
								<xsl:when test="string($t4)"><xsl:value-of select="$t4"/></xsl:when>
								<xsl:otherwise><xsl:value-of select="$DefaultItemSchemeID"/></xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						<xsl:choose>
							<xsl:when test="$t3 = 'GTIN'"><cbc:ID schemeAgencyID="9" schemeID="{$t3}"><xsl:value-of select="$t1"/></cbc:ID></xsl:when>
							<xsl:otherwise><cbc:ID schemeID="{$t3}"><xsl:value-of select="$t1"/></cbc:ID></xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$t4 = 'GTIN'"><cbc:ID schemeAgencyID="9" schemeID="{$t4}"><xsl:value-of select="$t1"/></cbc:ID></xsl:when>
							<xsl:otherwise><cbc:ID schemeID="{$t4}"><xsl:value-of select="$t1"/></cbc:ID></xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</cac:SellersItemIdentification>
			<xsl:apply-templates select="com:Item/com:ManufacturersItemIdentification">
				<xsl:with-param name="DefaultItemSchemeID" select="$DefaultItemSchemeID"/>
				<xsl:with-param name="UseDefaultItemSchemeID" select="$UseDefaultItemSchemeID"/>
			</xsl:apply-templates>
			<xsl:apply-templates select="com:Item/com:StandardItemIdentification">
				<xsl:with-param name="DefaultItemSchemeID" select="$DefaultItemSchemeID"/>
				<xsl:with-param name="UseDefaultItemSchemeID" select="$UseDefaultItemSchemeID"/>
			</xsl:apply-templates>
			<xsl:apply-templates select="com:Item/com:CatalogueItemIdentification">
				<xsl:with-param name="DefaultItemSchemeID" select="$DefaultItemSchemeID"/>
				<xsl:with-param name="UseDefaultItemSchemeID" select="$UseDefaultItemSchemeID"/>
			</xsl:apply-templates>
		</cac:Item>
	</xsl:template>


	<!-- Price template -->
	<xsl:template name="Price">
		<xsl:param name="CurrencyCode"/>
		<xsl:param name="DefaultUnitCode"/>
		<xsl:param name="UseDefaultUnitCode"/>
		<cac:Price>
			<cbc:PriceAmount currencyID="{$CurrencyCode}"><xsl:value-of select="com:BasePrice/com:PriceAmount"/></cbc:PriceAmount>
			<xsl:call-template name="UnitCode">
				<xsl:with-param name="p1" select="'price'"/>
				<xsl:with-param name="p2" select="com:BasePrice/com:BaseQuantity/@unitCode"/> 
				<xsl:with-param name="p3" select="com:BasePrice/com:BaseQuantity"/>
				<xsl:with-param name="DefaultUnitCode" select="$DefaultUnitCode"/>
				<xsl:with-param name="UseDefaultUnitCode" select="$UseDefaultUnitCode"/>
			</xsl:call-template>
			<cbc:OrderableUnitFactorRate>1</cbc:OrderableUnitFactorRate>
		</cac:Price>
	</xsl:template>


	<!-- BuyersItemIdentification template -->
	<xsl:template match="com:Item/com:BuyersItemIdentification">
		<xsl:param name="DefaultItemSchemeID"/>
		<xsl:param name="UseDefaultItemSchemeID"/>
		<cac:BuyersItemIdentification>
			<xsl:call-template name="ItemScheme">
				<xsl:with-param name="DefaultItemSchemeID" select="$DefaultItemSchemeID"/>
				<xsl:with-param name="UseDefaultItemSchemeID" select="$UseDefaultItemSchemeID"/>
			</xsl:call-template>
		</cac:BuyersItemIdentification>
	</xsl:template>


	<!-- ManufacturersItemIdentification template -->
	<xsl:template match="com:Item/com:ManufacturersItemIdentification">
		<xsl:param name="DefaultItemSchemeID"/>
		<xsl:param name="UseDefaultItemSchemeID"/>
		<cac:ManufacturersItemIdentification>
			<xsl:call-template name="ItemScheme">
				<xsl:with-param name="DefaultItemSchemeID" select="$DefaultItemSchemeID"/>
				<xsl:with-param name="UseDefaultItemSchemeID" select="$UseDefaultItemSchemeID"/>
			</xsl:call-template>
		</cac:ManufacturersItemIdentification>
	</xsl:template>


	<!-- StandardItemIdentification template -->
	<xsl:template match="com:Item/com:StandardItemIdentification">
		<xsl:param name="DefaultItemSchemeID"/>
		<xsl:param name="UseDefaultItemSchemeID"/>
		<cac:StandardItemIdentification>
			<xsl:call-template name="ItemScheme">
				<xsl:with-param name="DefaultItemSchemeID" select="$DefaultItemSchemeID"/>
				<xsl:with-param name="UseDefaultItemSchemeID" select="$UseDefaultItemSchemeID"/>
			</xsl:call-template>
		</cac:StandardItemIdentification>
	</xsl:template>


	<!-- CatalogueItemIdentification template -->
	<xsl:template match="com:Item/com:CatalogueItemIdentification">
		<xsl:param name="DefaultItemSchemeID"/>
		<xsl:param name="UseDefaultItemSchemeID"/>
		<cac:CatalogueItemIdentification>
			<xsl:call-template name="ItemScheme">
				<xsl:with-param name="DefaultItemSchemeID" select="$DefaultItemSchemeID"/>
				<xsl:with-param name="UseDefaultItemSchemeID" select="$UseDefaultItemSchemeID"/>
			</xsl:call-template>
		</cac:CatalogueItemIdentification>
	</xsl:template>


	<xsl:template name="ItemScheme">
		<xsl:param name="DefaultItemSchemeID"/>
		<xsl:param name="UseDefaultItemSchemeID"/>
		<xsl:variable name="t1"	select="com:ID"/>
		<xsl:variable name="t2"	select="com:ID/@schemeID"/>
		<xsl:variable name="t4">
			<xsl:choose>
				<xsl:when test="$t2 = 'EAN' or $t2 = 'EAN-13'">GTIN</xsl:when>
				<xsl:when test="not(string($t2))">n/a</xsl:when>
				<xsl:otherwise><xsl:value-of select="$t2"/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$UseDefaultItemSchemeID = 'true'">
				<xsl:variable name="t3">
					<xsl:choose>
						<xsl:when test="$t4 = 'n/a'"><xsl:value-of select="$DefaultItemSchemeID"/></xsl:when>
						<xsl:when test="string($t4)"><xsl:value-of select="$t4"/></xsl:when>
						<xsl:otherwise><xsl:value-of select="$DefaultItemSchemeID"/></xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:choose>
					<xsl:when test="$t3 = 'GTIN'"><cbc:ID schemeAgencyID="9" schemeID="{$t3}"><xsl:value-of select="$t1"/></cbc:ID></xsl:when>
					<xsl:otherwise><cbc:ID schemeID="{$t3}"><xsl:value-of select="$t1"/></cbc:ID></xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="$t4 = 'GTIN'"><cbc:ID schemeAgencyID="9" schemeID="{$t4}"><xsl:value-of select="$t1"/></cbc:ID></xsl:when>
					<xsl:otherwise><cbc:ID schemeID="{$t4}"><xsl:value-of select="$t1"/></cbc:ID></xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- AllowanceCharge template (call) -->
	<xsl:template name="AllowanceCharge">
		<xsl:param name="pID"/>
		<xsl:param name="pChargeIndicator"/>
		<xsl:param name="LineExtensionTotalAmount"/>
		<xsl:param name="CurrencyCode"/>
		<xsl:param name="CountryCode"/>
		<xsl:param name="DefaultMomsPercent"/>
		<xsl:variable name="t1">
			<xsl:choose>
				<xsl:when test="string(com:MultiplierReasonCode)"><xsl:value-of select="com:ID"/><xsl:text>, </xsl:text><xsl:value-of select="com:MultiplierReasonCode"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="com:ID"/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="t2">
			<xsl:choose>
				<xsl:when test="com:ChargeIndicator = 'true'">StandardRated</xsl:when>
				<xsl:otherwise>ZeroRated</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="t3">
			<xsl:choose>
				<xsl:when test="com:ChargeIndicator = 'true'"><xsl:value-of select="$DefaultMomsPercent"/></xsl:when>
				<xsl:otherwise>00</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- <xsl:variable name="t4" select="format-number(com:AllowanceChargeAmount div $LineExtensionTotalAmount, '.00000')"/> -->
		<cac:AllowanceCharge>
			<cbc:ID><xsl:value-of select="$pID"/></cbc:ID>
			<cbc:ChargeIndicator><xsl:value-of select="$pChargeIndicator"/></cbc:ChargeIndicator>
			<cbc:AllowanceChargeReason><xsl:value-of select="$t1"/></cbc:AllowanceChargeReason>
			<cbc:MultiplierFactorNumeric>1</cbc:MultiplierFactorNumeric>
			<cbc:SequenceNumeric>1</cbc:SequenceNumeric>
			<cbc:Amount currencyID="{$CurrencyCode}"><xsl:value-of select="com:AllowanceChargeAmount"/></cbc:Amount>
			<cbc:BaseAmount currencyID="{$CurrencyCode}"><xsl:value-of select="com:AllowanceChargeAmount"/></cbc:BaseAmount>
			<cac:TaxCategory>
				<cbc:ID schemeAgencyID="320" schemeID="urn:oioubl:id:taxcategoryid-1.1"><xsl:value-of select="$t2"/></cbc:ID>
				<cbc:Percent><xsl:value-of select="$t3"/></cbc:Percent>
				<cac:TaxScheme>
					<cbc:ID schemeAgencyID="320" schemeID="urn:oioubl:id:taxschemeid-1.1">63</cbc:ID>
					<cbc:Name>Moms</cbc:Name>
				</cac:TaxScheme>
			</cac:TaxCategory>
		</cac:AllowanceCharge>
	</xsl:template>


	<!-- AllowanceCharge template (match + mode) -->
	<xsl:template match="com:AllowanceCharge" mode="skat">
		<xsl:param name="LineExtensionTotalAmount"/>
		<xsl:param name="CurrencyCode"/>
		<xsl:param name="CountryCode"/>
		<xsl:variable name="t1"	select="com:ID"/>
		<xsl:variable name="t2">
			<xsl:choose>
				<xsl:when test="com:ChargeIndicator = 'true'">StandardRated</xsl:when>
				<xsl:otherwise>ZeroRated</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- <xsl:variable name="t3" select="com:MultiplierFactorQuantity"/> -->
		<!-- <xsl:variable name="t4" select="format-number(com:AllowanceChargeAmount div $LineExtensionTotalAmount, '.00000')"/> -->
		<xsl:variable name="t5">
			<xsl:choose>
				<xsl:when test="string(com:MultiplierReasonCode)"><xsl:value-of select="com:ID"/><xsl:text>, </xsl:text><xsl:value-of select="com:MultiplierReasonCode"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="com:ID"/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<cac:TaxTotal>
			<cbc:TaxAmount currencyID="{$CurrencyCode}"><xsl:value-of select="com:AllowanceChargeAmount"/></cbc:TaxAmount>
			<cac:TaxSubtotal>
				<cbc:TaxableAmount currencyID="{$CurrencyCode}"><xsl:value-of select="com:AllowanceChargeAmount"/></cbc:TaxableAmount>
				<cbc:TaxAmount currencyID ="{$CurrencyCode}"><xsl:value-of select="com:AllowanceChargeAmount"/></cbc:TaxAmount>
				<cac:TaxCategory>
					<cbc:ID schemeAgencyID="320" schemeID="urn:oioubl:id:taxcategoryid-1.1">Excise</cbc:ID>
					<cbc:BaseUnitMeasure unitCode="EA">1.00</cbc:BaseUnitMeasure>
					<cbc:PerUnitAmount currencyID="{$CurrencyCode}"><xsl:value-of select="com:AllowanceChargeAmount"/></cbc:PerUnitAmount>
					<cac:TaxScheme>
						<cbc:ID schemeAgencyID="320" schemeID="urn:oioubl:id:taxschemeid-1.1">0</cbc:ID>
						<cbc:Name>Uspecificerede punktafgifter</cbc:Name>
						<cbc:TaxTypeCode listAgencyID="320" listID="urn:oioubl:codelist:taxtypecode-1.1"><xsl:value-of select="$t2"/></cbc:TaxTypeCode>
					</cac:TaxScheme>
				</cac:TaxCategory>
			</cac:TaxSubtotal>
		</cac:TaxTotal>
	</xsl:template>


	<!-- TaxTotal template (match) -->
	<xsl:template match="com:TaxTotal">
		<xsl:param name="CurrencyCode"/>
		<xsl:param name="CountryCode"/>
		<xsl:variable name="t1">
			<xsl:choose>
				<xsl:when test="com:TaxTypeCode = 'ZERO-RATED'"><xsl:value-of select="'ZeroRated'"/></xsl:when>
				<xsl:otherwise>StandardRated</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="t2"	select="format-number(com:CategoryTotal/com:TaxAmounts/com:TaxAmount, '0.00')"/>
		<cac:TaxSubtotal>
			<cbc:TaxableAmount currencyID="{$CurrencyCode}"><xsl:value-of select="com:CategoryTotal/com:TaxAmounts/com:TaxableAmount"/></cbc:TaxableAmount>
			<cbc:TaxAmount currencyID ="{$CurrencyCode}"><xsl:value-of select="$t2"/></cbc:TaxAmount>
			<cac:TaxCategory>
				<cbc:ID schemeAgencyID="320" schemeID="urn:oioubl:id:taxcategoryid-1.1"><xsl:value-of select="$t1"/></cbc:ID>
				<cbc:Percent><xsl:value-of select="com:CategoryTotal/com:RatePercentNumeric"/></cbc:Percent>
				<cac:TaxScheme>
					<cbc:ID schemeAgencyID="320" schemeID="urn:oioubl:id:taxschemeid-1.1">63</cbc:ID>
					<cbc:Name>Moms</cbc:Name>
				</cac:TaxScheme>
			</cac:TaxCategory>
		</cac:TaxSubtotal>
	</xsl:template>


	<!-- EndpointID template -->
	<xsl:template name="EndpointID">
		<xsl:param name="BuyersReferenceID"/>
		<xsl:variable name="t1"	select="com:ID"/>
		<xsl:variable name="t2"	select="com:ID/@schemeID"/>
		<xsl:variable name="t4">
			<xsl:choose>
				<xsl:when test="string($t1)"><xsl:value-of select="$t1"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="$BuyersReferenceID"/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="t5">
			<xsl:choose>
				<xsl:when test="string($t2)"><xsl:value-of select="$t2"/></xsl:when>
				<xsl:otherwise>GLN</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="t6">
			<xsl:choose>
				<xsl:when test="name(.) = 'com:SellerParty'"><xsl:value-of select="$t1"/></xsl:when>
				<xsl:when test="com:Address/com:ID = 'Juridisk'"><xsl:value-of select="$t4"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="$BuyersReferenceID"/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="t7">
			<xsl:choose>
				<xsl:when test="name(.) = 'com:SellerParty'"><xsl:value-of select="$t2"/></xsl:when>
				<xsl:when test="com:Address/com:ID = 'Juridisk'"><xsl:value-of select="$t5"/></xsl:when>
				<xsl:otherwise>GLN</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$t7 = 'CVR' or $t7 = 'CPR'">
				<cbc:EndpointID schemeID="DK:{$t7}">DK<xsl:value-of select="$t6"/></cbc:EndpointID>
			</xsl:when>

			<xsl:when test="$t7 = 'EAN' or $t7 = 'GLN'">
				<cbc:EndpointID schemeAgencyID="9" schemeID="GLN"><xsl:value-of select="$t6"/></cbc:EndpointID>
			</xsl:when>

			<xsl:when test="$t5 = 'SE'">
				<cbc:EndpointID schemeID="DK:CVR">DK<xsl:value-of select="$t6"/></cbc:EndpointID>
			</xsl:when>

			<xsl:otherwise>
				<cbc:EndpointID schemeID="{$t2}"><xsl:value-of select="$t1"/></cbc:EndpointID>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- PartyIdentification template -->
	<xsl:template name="PartyIdentification">
		<xsl:if test="string(com:ID)">
			<xsl:variable name="t1"	select="com:ID"/>
			<xsl:variable name="t2"	select="com:ID/@schemeID"/>
			<cac:PartyIdentification>
				<xsl:choose>
					<xsl:when test="$t2 = 'CVR' or $t2 = 'CPR'">
						<cbc:ID schemeID="DK:{$t2}">DK<xsl:value-of select="$t1"/></cbc:ID>
					</xsl:when>
					<xsl:when test="$t2 = 'SE'">
						<cbc:ID schemeID="DK:CVR">DK<xsl:value-of select="$t1"/></cbc:ID>
					</xsl:when>
					<xsl:when test="$t2 = 'EAN' or $t2 = 'GLN'">
						<cbc:ID schemeAgencyID="9" schemeID="GLN"><xsl:value-of select="$t1"/></cbc:ID>
					</xsl:when>
					<xsl:otherwise>
						<cbc:ID schemeID="{$t2}"><xsl:value-of select="$t1"/></cbc:ID>
					</xsl:otherwise>
				</xsl:choose>
			</cac:PartyIdentification>
		</xsl:if>
	</xsl:template>


	<!-- PartyName template -->
	<xsl:template name="PartyName">
		<xsl:param name="p1"/>
		<xsl:if test="string($p1)">
			<cac:PartyName>
				<cbc:Name><xsl:value-of select="$p1"/></cbc:Name>
			</cac:PartyName>
		</xsl:if>
	</xsl:template>


	<!-- Address template -->
	<xsl:template name="Address">
		<xsl:param name="p1"/>
		<xsl:param name="p2"/>
		<xsl:param name="p3"/>
		<xsl:param name="p4"/>
		<xsl:param name="p5"/>
		<xsl:param name="p6"/>
		<xsl:param name="p7"/>
		<xsl:param name="p8"/>
		<xsl:param name="p9"/>
		<xsl:param name="CountryCode"/>
		<xsl:variable name="t1">
       			<xsl:choose>
				<xsl:when test="string($p8)"><xsl:value-of select="$p8"/></xsl:when>
	  			<xsl:otherwise><xsl:value-of select="$CountryCode"/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- <xsl:if test="string($p1)"><cbc:ID><xsl:value-of select="$p1"/></cbc:ID></xsl:if> -->
		<cbc:AddressFormatCode listAgencyID="320" listID="urn:oioubl:codelist:addressformatcode-1.1">StructuredLax</cbc:AddressFormatCode>
		<xsl:if test="string($p2)"><cbc:StreetName><xsl:value-of select="$p2"/></cbc:StreetName></xsl:if>
		<xsl:if test="string($p3)"><cbc:AdditionalStreetName><xsl:value-of select="$p3"/></cbc:AdditionalStreetName></xsl:if>
		<xsl:if test="string($p4)"><cbc:BuildingNumber><xsl:value-of select="$p4"/></cbc:BuildingNumber></xsl:if>
		<xsl:if test="string($p5)"><cbc:InhouseMail><xsl:value-of select="$p5"/></cbc:InhouseMail></xsl:if>
		<xsl:if test="string($p9)"><cbc:MarkAttention><xsl:value-of select="$p9"/></cbc:MarkAttention></xsl:if>
		<xsl:if test="string($p6)"><cbc:CityName><xsl:value-of select="$p6"/></cbc:CityName></xsl:if>
		<xsl:if test="string($p7)"><cbc:PostalZone><xsl:value-of select="$p7"/></cbc:PostalZone></xsl:if>
		<cac:Country>
			<cbc:IdentificationCode><xsl:value-of select="$t1"/></cbc:IdentificationCode>
		</cac:Country>
	</xsl:template>


	<!-- PartyTaxScheme template -->
	<xsl:template name="PartyTaxScheme">
		<xsl:if test="string(com:PartyTaxScheme)">
			<cac:PartyTaxScheme>
				<cbc:CompanyID schemeID="DK:SE">DK<xsl:value-of select="com:PartyTaxScheme/com:CompanyTaxID"/></cbc:CompanyID>
				<cac:TaxScheme>
					<cbc:ID schemeAgencyID="320" schemeID="urn:oioubl:id:taxschemeid-1.1">63</cbc:ID>
					<cbc:Name>Moms</cbc:Name>
				</cac:TaxScheme>
			</cac:PartyTaxScheme>
		</xsl:if>
	</xsl:template>


	<!-- PartyLegalEntity template -->
	<xsl:template name="PartyLegalEntity">
		<xsl:variable name="t1"	select="com:ID"/>
		<xsl:variable name="t2"	select="com:ID/@schemeID"/>
		<xsl:variable name="t3"	select="com:PartyTaxScheme/com:CompanyTaxID"/>
		<xsl:variable name="t4"	select="com:PartyTaxScheme/com:CompanyTaxID/@schemeID"/>
		<xsl:variable name="t5">
       			<xsl:choose>
				<xsl:when test="$t2 = 'CVR' or $t2 = 'SE'">DK<xsl:value-of select="$t1"/></xsl:when>
				<xsl:when test="$t4 = 'CVR' or $t4 = 'SE'">DK<xsl:value-of select="$t3"/></xsl:when>
	  			<xsl:otherwise>n/a</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="$t5 != 'n/a'">
			<cac:PartyLegalEntity>
				<xsl:if test="string(com:PartyName/com:Name)"><cbc:RegistrationName><xsl:value-of select="com:PartyName/com:Name"/></cbc:RegistrationName></xsl:if>
				<cbc:CompanyID schemeID="DK:CVR"><xsl:value-of select="$t5"/></cbc:CompanyID>
			</cac:PartyLegalEntity>

		</xsl:if>
	</xsl:template>


	<!-- Contact template -->
	<xsl:template name="Contact">
		<xsl:if test="string(com:BuyerContact)">
			<cac:Contact>
				<xsl:if test="string(com:BuyerContact/com:ID)"><cbc:ID><xsl:value-of select="com:BuyerContact/com:ID"/></cbc:ID></xsl:if>
				<xsl:if test="string(com:BuyerContact/com:Name)"><cbc:Name><xsl:value-of select="com:BuyerContact/com:Name"/></cbc:Name></xsl:if>
				<xsl:if test="string(com:BuyerContact/com:Phone)"><cbc:Telephone><xsl:value-of select="com:BuyerContact/com:Phone"/></cbc:Telephone></xsl:if>
				<xsl:if test="string(com:BuyerContact/com:Fax)"><cbc:Telefax><xsl:value-of select="com:BuyerContact/com:Fax"/></cbc:Telefax></xsl:if>
				<xsl:if test="string(com:BuyerContact/com:E-Mail)"><cbc:ElectronicMail><xsl:value-of select="com:BuyerContact/com:E-Mail"/></cbc:ElectronicMail></xsl:if>
			</cac:Contact>
		</xsl:if>
		<xsl:if test="string(com:OrderContact)">
			<cac:Contact>
				<xsl:if test="string(com:OrderContact/com:ID)"><cbc:ID><xsl:value-of select="com:OrderContact/com:ID"/></cbc:ID></xsl:if>
				<xsl:if test="string(com:OrderContact/com:Name)"><cbc:Name><xsl:value-of select="com:OrderContact/com:Name"/></cbc:Name></xsl:if>
				<xsl:if test="string(com:OrderContact/com:Phone)"><cbc:Telephone><xsl:value-of select="com:OrderContact/com:Phone"/></cbc:Telephone></xsl:if>
				<xsl:if test="string(com:OrderContact/com:Fax)"><cbc:Telefax><xsl:value-of select="com:OrderContact/com:Fax"/></cbc:Telefax></xsl:if>
				<xsl:if test="string(com:OrderContact/com:E-Mail)"><cbc:ElectronicMail><xsl:value-of select="com:OrderContact/com:E-Mail"/></cbc:ElectronicMail></xsl:if>
			</cac:Contact>
		</xsl:if>
	</xsl:template>


	<!-- UnitCode template -->
	<xsl:template name="UnitCode">
		<xsl:param name="p1"/>
		<xsl:param name="p2"/>
		<xsl:param name="p3"/>
		<xsl:param name="DefaultUnitCode"/>
		<xsl:param name="UseDefaultUnitCode"/>
		<xsl:choose>
			<xsl:when test="$UseDefaultUnitCode = 'true'">
				<xsl:variable name="t2">
					<xsl:choose>
						<xsl:when test="$p2 = 'PCE'"><xsl:value-of select="$DefaultUnitCode"/></xsl:when>
						<xsl:when test="$p2 = 'STK'"><xsl:value-of select="$DefaultUnitCode"/></xsl:when>
						<xsl:when test="$p2 = 'Stk'"><xsl:value-of select="$DefaultUnitCode"/></xsl:when>
						<xsl:when test="string($p2)"><xsl:value-of select="$p2"/></xsl:when>
						<xsl:otherwise><xsl:value-of select="$DefaultUnitCode"/></xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="t3">
					<xsl:choose>
						<xsl:when test="string($p3)"><xsl:value-of select="$p3"/></xsl:when>
						<xsl:otherwise>1</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:choose>
					<xsl:when test="$p1 = 'price'"><cbc:BaseQuantity unitCode="{$t2}"><xsl:value-of select="$t3"/></cbc:BaseQuantity></xsl:when>
					<xsl:when test="$p1 = 'invqu'"><cbc:CreditedQuantity unitCode="{$t2}"><xsl:value-of select="$t3"/></cbc:CreditedQuantity></xsl:when>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="$p1 = 'price'"><cbc:BaseQuantity unitCode="{$p2}"><xsl:value-of select="$p3"/></cbc:BaseQuantity></xsl:when>
					<xsl:when test="$p1 = 'invqu'"><cbc:CreditedQuantity unitCode="{$p2}"><xsl:value-of select="$p3"/></cbc:CreditedQuantity></xsl:when>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
