/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain
 * a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *
 * The Original Code is Java RASP toolkit.
 *
 * The Initial Developer of the Original Code is Lenio. Portions
 * created by Lenio are Copyright (C) 2007 Danish National IT and 
 * Telecom Agency (http://www.itst.dk). All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Dejbjerg Pedersen, Lenio
 *   Hans Guldager Knudsen, Lenio
 *   Patrik Johansson, Accenture
 *   Dennis S�gaard, Accenture
 *   Martin Bentzen, Accenture
 *   Jesper Jensen, Avanade
 *   Ramzi Fadel, Avanade
 *   Christian Pedersen, Accenture
 *   Morten Hougesen, Accenture
 *   Mikkel Hippe Brun, ITST
 *   Finn Hartmann Jordal, ITST
 *   Christian Lanng, ITST
 *
 */

package dk.gov.oiosi.test;

/**
 * Constants for testing.
 */
public class TestConstants {

    public static final String PATH_APPLICATIONRESPONSE201_XML = "test/resources/xml/OIOUBL_ApplicationResponse_v2p1.xml";
    public static final String PATH_APPLICATIONRESPONSE202_XML = "test/resources/xml/OIOUBL_ApplicationResponse_v2p2.xml";
	public static final String PATH_CATALOGUE_XML = "test/resources/xml/OIOUBL_Catalogue_v2p2.xml";
	public static final String PATH_CATALOGUEDELETION_XML = "test/resources/xml/OIOUBL_CatalogueDeletion_v2p1.xml";
	public static final String PATH_CATALOGUEITEMSPECIFICATIONUPDATE_XML = "test/resources/xml/OIOUBL_CatalogueItemSpecificationUpdate_v2p1.xml";
	public static final String PATH_CATALOGUEPRICINGUPDATE_XML = "test/resources/xml/OIOUBL_CataloguePricingUpdate_v2p1.xml";
	public static final String PATH_CATALOGUEREQUEST_XML = "test/resources/xml/OIOUBL_CatalogueRequest_v2p1.xml";
    public static final String PATH_CREDITNOTE_XML = "test/resources/xml/OIOUBL_CreditNote_v2p1.xml";
    public static final String PATH_CREDITNOTE07_XML = "test/resources/xml/OIOXML_CreditNote_v0.7.xml";
    public static final String PATH_INVOICE_XML = "test/resources/xml/OIOUBL_Invoice_v2p1.xml";
    public static final String PATH_INVOICE07_XML = "test/resources/xml/OIOXML_Invoice_v0.7.xml";
    public static final String PATH_INVOICEWRONGELEMENT_XML = "test/resources/xml/OIOUBL_Invoice_v2p1_WrongElement.xml";
    public static final String PATH_INVOICEWRONGNAMESPACE_XML = "test/resources/xml/OIOUBL_Invoice_v2p1_WrongNamespace.xml";
    public static final String PATH_INVOICENOID_XML = "test/resources/xml/OIOUBL_Invoice_v2p1_NoId.xml";
    public static final String PATH_INVOICEN7INVALIDEANNUMBER_XML = "test/resources/xml/OIOXML_Invoice_Invalid_EanNumber_v0.7.xml";
    public static final String PATH_ORDER_XML = "test/resources/xml/OIOUBL_Order_v2p1.xml";
	public static final String PATH_ORDERCANCELLATION_XML = "test/resources/xml/OIOUBL_OrderCancellation_v2p1.xml";
	public static final String PATH_ORDERCHANGE_XML = "test/resources/xml/OIOUBL_OrderChange_v2p1.xml";
	public static final String PATH_ORDERRESPONSE_XML = "test/resources/xml/OIOUBL_OrderResponse_v2p1.xml";
    public static final String PATH_ORDERRESPONSESIMPLE_XML = "test/resources/xml/OIOUBL_OrderResponseSimple_v2p1.xml";
    public static final String PATH_REMINDER_XML = "test/resources/xml/OIOUBL_Reminder_v2p1.xml";
	public static final String PATH_STATEMENT_XML = "test/resources/xml/OIOUBL_Statement_v2p1.xml";
	public static final String PATH_UTILITYSTATEMENT_XML = "test/resources/xml/OIOUBL_UtilityStatement_v2p2.xml";    public static final String PATH_UNKNOWNTYPE_XML = "test/resources/xml/UnknownType.xml";
    public static final String PATH_NONAMESPACE_XML = "test/resources/xml/NoNamespace.xml";

    
    public static final String PATH_APPLICATIONRESPONSE_XSD = "resources/schemas/UBL v2.0/maindoc/UBL-ApplicationResponse-2.0.xsd";
    public static final String PATH_CREDITNOTE_XSD = "resources/schemas/UBL v2.0/maindoc/UBL-CreditNote-2.0.xsd";
    public static final String PATH_INVOICE_XSD = "resources/schemas/UBL v2.0/maindoc/UBL-Invoice-2.0.xsd";
    public static final String PATH_INVOICE07_XSD = "resources/schemas/OIOXML v0.7/pieStrict.xsd";
    public static final String PATH_NOTIFICATION_XSD = "resources/schemas/UBL v2.0/maindoc/Notification.xsd";
    public static final String PATH_ORDER_XSD = "resources/schemas/UBL v2.0/maindoc/UBL-Order-2.0.xsd";
    public static final String PATH_ORDERRESPONSESIMPLE_XSD = "resources/schemas/UBL v2.0/maindoc/UBL-OrderResponseSimple-2.0.xsd";
    public static final String PATH_REMINDER_XSD = "resources/schemas/UBL v2.0/maindoc/UBL-Reminder-2.0.xsd";

    public static final String PATH_APPLICATIONRESPONSE_XSL = "resources/schematronstylesheets/OIOUBL v2.01/OIOUBL_ApplicationResponse_Schematron.xsl";
    public static final String PATH_CREDITNOTE_XSL = "resources/schematronstylesheets/OIOUBL v2.01/OIOUBL_CreditNote_Schematron.xsl";
    public static final String PATH_INVOICE_XSL = "resources/schematronstylesheets/OIOUBL v2.01/OIOUBL_Invoice_Schematron.xsl";
    public static final String PATH_INVOICE07_XSL = "resources/schematronstylesheets/OIOUBL v0.7/ublinvoice.xsl";
    public static final String PATH_ORDER_XSL = "resources/schematronstylesheets/OIOUBL v2.01/OIOUBL_Order_Schematron.xsl";
    public static final String PATH_ORDERRESPONSESIMPLE_XSL = "resources/schematronstylesheets/OIOUBL v2.01/OIOUBL_OrderResponseSimple_Schematron.xsl";
    public static final String PATH_REMINDER_XSL = "resources/schematronstylesheets/OIOUBL v2.01/OIOUBL_Reminder_Schematron.xsl";

    public static final String PATH_CERTIFICATE_ORGANISATION = "test/resources/certificates/virksomhed.cer";
    public static final String PATH_CERTIFICATE_PERSON = "test/resources/certificates/person.cer";
    public static final String PATH_CERTIFICATE_EMPLOYEE = "test/resources/certificates/medarbejder.cer";
    public static final String PATH_CERTIFICATE_DEVICE = "test/resources/certificates/device.cer";
    public static final String PATH_CERTIFICATE_DEVICE_TEST = "test/resources/certificates/device_test.cer";
    public static final String PATH_CERTIFICATE_TEST_ROOT = "test/resources/certificates/oces_test_root.cer";
    public static final String PATH_CERTIFICATE_ROOT = "test/resources/certificates/ocesca.cer";
    public static final String PATH_CERTIFICATE_VALID = "test/resources/certificates/nemhandel_test_service.cer";
    
    public static final String TEST_CERTIFICATE_SUBJECT_FUNCTION = "SERIALNUMBER=CVR:26769388-FID:1272375084431 + CN=Test NemHandelservice (funktionscertifikat), O=IT- og Telestyrelsen // CVR:26769388, C=DK";
    public static final String TEST_CERTIFICATE_SUBJECT_COMPANY = "CN=DANID A/S - DanID Test + SERIALNUMBER=CVR:30808460-UID:1237552804997, O=DANID A/S // CVR:30808460, C=DK";

    public static final String PATH_KEYSTORE_TEST = "./test/resources/keys/oiosi_test_certificates.jks";
    public static final String PASSWORD_KEYSTORE_TEST = "Test1234";
	
    public static final String PATH_INVOICE_XML_IDENTIFIER_EAN = "test/resources/xml/OIOUBL_Invoice_identifier_ean_v2p1.xml";
	public static final String PATH_INVOICE_XML_IDENTIFIER_OVT = "test/resources/xml/OIOUBL_Invoice_identifier_ovt_v2p1.xml";
	public static final String PATH_INVOICE_XML_IDENTIFIER_CVR = "test/resources/xml/OIOUBL_Invoice_identifier_cvr_v2p1.xml";
	public static final String PATH_INVOICE_XML_IDENTIFIER_P = "test/resources/xml/OIOUBL_Invoice_identifier_p_v2p1.xml";
	public static final String PATH_INVOICE_XML_IDENTIFIER_SE = "test/resources/xml/OIOUBL_Invoice_identifier_se_v2p1.xml";
	public static final String PATH_INVOICE_XML_IDENTIFIER_VANS = "test/resources/xml/OIOUBL_Invoice_identifier_vans_v2p1.xml";
	public static final String PATH_INVOICE_XML_IDENTIFIER_IBAN = "test/resources/xml/OIOUBL_Invoice_identifier_iban_v2p1.xml";
	public static final String PATH_INVOICE_XML_IDENTIFIER_DUNS = "test/resources/xml/OIOUBL_Invoice_identifier_duns_v2p1.xml";
    
	public static final String PATH_TEST_RASPCONFIGURATION = "./test/conf/RaspTestConfiguration.xml";
	
}
