package dk.gov.oiosi.test.integration.uddi;

import static org.junit.Assert.*;

import java.net.URISyntaxException;
import java.util.LinkedList;
import java.util.List;

import org.junit.Before;
import org.junit.Test;

import dk.gov.oiosi.configuration.ConfigurationHandler;
import dk.gov.oiosi.exception.MainException;
import dk.gov.oiosi.test.TestConstants;
import dk.gov.oiosi.uddi.EndpointAddressTypeCode;
import dk.gov.oiosi.uddi.IUddiLookupClient;
import dk.gov.oiosi.uddi.ProcessDefinition;
import dk.gov.oiosi.uddi.RegistryLookupClientFactory;
import dk.gov.oiosi.uddi.UddiConfig;
import dk.gov.oiosi.uddi.UddiGuidId;
import dk.gov.oiosi.uddi.UddiId;

public class RegistryLookupClientTest {
    
	@Before
    public void SetupUddi() throws URISyntaxException {
    	//ConfigurationUtil.SetupConfiguration();
    	ConfigurationHandler.setConfigurationFile(TestConstants.PATH_TEST_RASPCONFIGURATION);
    }
	
	@Test
	public void getProcessDefinitions() throws MainException {
        List<UddiId> uddiIds = new LinkedList<UddiId>();
        uddiIds.add(new UddiGuidId("uddi:AEE8B6DE-298F-4cbc-A96D-9AE8AED0AC31", true));
        uddiIds.add(new UddiGuidId("uddi:c001daa0-8ba3-11dd-894e-770465b08940", true));

        IUddiLookupClient ulc = RegistryLookupClientFactory.getRegistryLookupClient();
        List<ProcessDefinition> processes = ulc.GetProcessDefinitions(uddiIds);
        assertEquals(uddiIds.size(), processes.size());
     }
}
