package dk.gov.oiosi.test.stubs;

import java.net.URISyntaxException;
import java.security.cert.X509Certificate;
import java.util.Calendar;

import dk.gov.oiosi.configuration.ConfigurationHandler;
import dk.gov.oiosi.exception.ArgumentNullException;
import dk.gov.oiosi.security.revocation.IRevocationLookup;
import dk.gov.oiosi.security.revocation.RevocationException;
import dk.gov.oiosi.security.revocation.RevocationResponse;
import dk.gov.oiosi.security.revocation.ocsp.OcspConfig;

public class RevocationLookupStub implements IRevocationLookup {

	public RevocationResponse checkCertificate(X509Certificate certificate)
			throws RevocationException {
	
		if(certificate == null) throw new ArgumentNullException("certificate");
		RevocationResponse result = new RevocationResponse();
		result.setIsValid(ConfigurationHandler.getInstance().getRevocationTestConfig());
		Calendar nextUpdate = Calendar.getInstance();
		nextUpdate.add(0, 100);
		result.setNextUpdate(nextUpdate.getTime());
		return result;
	}

	public OcspConfig getConfiguration() throws URISyntaxException {
		return ConfigurationHandler.getInstance().getOcspConfig();
	}

}
