package dk.gov.oiosi.test.unit.xml.schematron;

import javax.xml.transform.Transformer;

import junit.framework.Assert;
import junit.framework.TestCase;

import dk.gov.oiosi.communication.configuration.DocumentTypeConfig;
import dk.gov.oiosi.configuration.ConfigurationHandler;
import dk.gov.oiosi.test.TestConstants;
import dk.gov.oiosi.xml.XmlDocument;
import dk.gov.oiosi.xml.documenttype.DocumentTypeConfigSearcher;
import dk.gov.oiosi.xml.schematron.SchematronStore;

public class SchematronStoreTest extends TestCase {
	
	static {
		 ConfigurationHandler.setConfigurationFile(TestConstants.PATH_TEST_RASPCONFIGURATION);
	}
	
    public void test_01_GetOnce() throws Exception {
        XmlDocument document = new XmlDocument();
        document.load(TestConstants.PATH_INVOICE_XML);
        DocumentTypeConfigSearcher searcher = new DocumentTypeConfigSearcher();
        DocumentTypeConfig documentTypeConfig = searcher.findUniqueDocumentType(document);
        SchematronStore store = new SchematronStore();
        Transformer transform = store.getCompiledSchematron(documentTypeConfig.getSchematronValidationConfig().getSchematronDocumentPath());
        Assert.assertNotNull(transform);
    }

    public void test_02_GetTwice() throws Exception {
        XmlDocument document = new XmlDocument();
        document.load(TestConstants.PATH_INVOICE_XML);
        DocumentTypeConfigSearcher searcher = new DocumentTypeConfigSearcher();
        DocumentTypeConfig documentTypeConfig = searcher.findUniqueDocumentType(document);
        SchematronStore store = new SchematronStore();
        Transformer transform1 = store.getCompiledSchematron(documentTypeConfig.getSchematronValidationConfig().getSchematronDocumentPath());
        Assert.assertNotNull(transform1);
        Transformer transform2 = store.getCompiledSchematron(documentTypeConfig.getSchematronValidationConfig().getSchematronDocumentPath());
        Assert.assertNotNull(transform2);
    }

    public void test_03_GetTenTimes() throws Exception {
        XmlDocument document = new XmlDocument();
        document.load(TestConstants.PATH_INVOICE_XML);
        DocumentTypeConfigSearcher searcher = new DocumentTypeConfigSearcher();
        DocumentTypeConfig documentTypeConfig = searcher.findUniqueDocumentType(document);
        SchematronStore store = new SchematronStore();
        Transformer transform1 = store.getCompiledSchematron(documentTypeConfig.getSchematronValidationConfig().getSchematronDocumentPath());
        Assert.assertNotNull(transform1);
        for (int i = 0; i < 9; i++) {
        	Transformer transform2 = store.getCompiledSchematron(documentTypeConfig.getSchematronValidationConfig().getSchematronDocumentPath());
            Assert.assertNotNull(transform2);
        }
    }
}
